"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.interface_field = exports.interface_type_interfaces = exports.declare_interface_type = void 0;
const graphql_1 = require("graphql");
const codetpl_1 = require("../lib/codetpl");
const utils_1 = require("./utils");
const declare_interface_type = (ctx, e) => (0, codetpl_1.codetpl) `
    export type ${e.name.value} = ${(0, exports.interface_type_interfaces)(ctx, e)} {
      __typename?: '${e.name.value}';
      ${(0, codetpl_1.MAP)(e.fields, v => (0, exports.interface_field)(ctx, v))}
    }

    `;
exports.declare_interface_type = declare_interface_type;
const interface_type_interfaces = (ctx, v) => v.interfaces ? v.interfaces.map((i) => `${i.name.value} & `).join("") : "";
exports.interface_type_interfaces = interface_type_interfaces;
const interface_field = (ctx, v) => (0, codetpl_1.codetpl) `
    ${v.name.value}${conditional(ctx, v)}: ${(0, utils_1.typename)(ctx, v.type)};
    `;
exports.interface_field = interface_field;
const conditional = (ctx, v) => v.type.kind === graphql_1.Kind.NON_NULL_TYPE ? "" : "?";
//# sourceMappingURL=interfaces.js.map