"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.resolver_codes = exports.imports_codes = void 0;
const enums_1 = require("./enums");
const scalars_1 = require("./scalars");
const codetpl_1 = require("../lib/codetpl");
const unions_1 = require("./unions");
const resolvers_1 = require("./resolvers");
const objects_1 = require("./objects");
const interfaces_1 = require("./interfaces");
const inputObjects_1 = require("./inputObjects");
const imports_codes = (ctx) => (0, codetpl_1.codetpl) `

    import { GraphQLResolveInfo, GraphQLScalarType, GraphQLScalarTypeConfig } from 'graphql';

    `;
exports.imports_codes = imports_codes;
const resolver_codes = (ctx) => (0, codetpl_1.codetpl) `
    // this file is generated by code generator

    // scalar types -----------------------------
    ${(0, scalars_1.declare_scalar_type)(ctx, ctx.scalars)}

    // union types ------------------------------
    ${(0, codetpl_1.MAP)(ctx.unionNodes, v => (0, unions_1.declare_union_type)(ctx, v))}

    // enum types -------------------------------
    ${(0, codetpl_1.MAP)(ctx.enumNodes, v => (0, enums_1.declare_enum_type)(ctx, v))}

    // object types -----------------------------
    ${(0, codetpl_1.MAP)(ctx.objectNodes, v => (0, objects_1.declare_object_type)(ctx, v))}

    // interface types --------------------------
    ${(0, codetpl_1.MAP)(ctx.interfaceNodes, v => (0, interfaces_1.declare_interface_type)(ctx, v))}

    // input types ------------------------------
    ${(0, codetpl_1.MAP)(ctx.inputObjectNodes, v => (0, inputObjects_1.declare_inputObject_type)(ctx, v))}

    // resolver types ---------------------------
    ${(0, codetpl_1.MAP)(ctx.objectNodes, v => (0, resolvers_1.declare_resolver_type)(ctx, v))}

    // all resolvers ----------------------------
    ${(0, resolvers_1.declare_all_resolvers_type)(ctx)}
    `;
exports.resolver_codes = resolver_codes;
//# sourceMappingURL=main.js.map